#pragma once

#include <dune/common/rangeutilities.hh>

#include <amdis/typetree/MultiIndex.hpp>
#include <amdis/utility/MappedRangeView.hpp>

namespace AMDiS
{
  /// Returns a range over the DOF indices on a node, given by the localView
  template <class LocalView, class Node>
  auto nodeIndices(LocalView const& localView, Node const& node)
  {
    return mappedRangeView(Dune::range(node.size()), [&](std::size_t j) {
      return flatMultiIndex(localView.index(node.localIndex(j)));
    });
  }

  /// Returns a range over the DOF indices on the basis tree, given by the localView
  template <class LocalView>
  auto nodeIndices(LocalView const& localView)
  {
    return mappedRangeView(Dune::range(localView.size()), [&](std::size_t i) {
      return flatMultiIndex(localView.index(i));
    });
  }

} // end namespace AMDiS
